/*IR-Receiver und Dekode, Revision:00
  Copyright: Ing. M. Cech, elektronische Gerte, A-2432 Schwadorf

  enthlt main-function

  Autor: M. Cech
  (C) Ing. M. Cech, elektronische Gerte
  Lagerhausstr.12, A-2432 Schwadorf

  Datum: 21/08/2004
  Rev.:00

  Compiler options: Strings in flash only, small model of printf, 8515

  Revision history:

*/

// Target: AT90S8535

#include <iom8535v.h>
#include <macros.h>
#include "Muster_BaseType.h"
#include "Muster_Prot.h"
#include "Muster_Tables.h"

//------------------------------------------------------------------------------------------------------------
//Globals
volatile unsigned char  gl_T0_aux_1;
volatile unsigned char  gl_T0_wait=0;             //Wartezeit vor dem Demuten
volatile unsigned int   gl_T0_100m_motor_up=0;    //Motorlaufzeit hinauf
volatile unsigned int   gl_T0_100m_motor_down=0;  //Motorlaufzeit herab

volatile UInt8	T0_Var1=0;

unsigned char gl_Timer0_10msec=10;
unsigned char gl_Timer0_100msec=100;

//unsigned char gl_Timer0_Test_lock=0;              // Test CS8420-Lock
unsigned char gl_TIRWait=0;
unsigned char gl_TComExt=0;

UInt8 init_tab[] = {
  FUNCTION_SET,
  LCD_CLEAR,
  LCD_OFF,
  LCD_ON,
  LCD_CLEAR
};

const UInt8 headline1[]="  ITM-PRAKTIKER ";
const UInt8 headline2[]="    wuenscht    ";
const UInt8 headline3[]="   viel Spass   ";
const UInt8 headline4[]="     mit dem    ";
const UInt8 headline5[]="    u-Butler!   ";


//------------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------------



//------------------------------------------------------------------------------------------------------------
/* Timer 0 will be used as general purpose 1 msec. timer, servicing several time registers
*/
#pragma interrupt_handler timer0_ovf_isr:10
void timer0_ovf_isr(void)  /* */
{
 unsigned char c_var1=0;

 TCNT0 = 0x06; //reload counter value, 1 msec. rate

 /*-------------------------------------------------*/

 /*-------------------------------------------------*/
 /* 1 msec. timers */

 if(T0_Var1)
  -- T0_Var1;

  if(gl_T0_wait)
    gl_T0_wait--;

 /*----------------*/
 /* 10 msec. Cascade */
 if(gl_Timer0_10msec)
  gl_Timer0_10msec--;
 else {
  gl_Timer0_10msec=10;


  if(gl_T0_aux_1)
    gl_T0_aux_1--;

 }

 /*----------------*/
 /* 100 msec. Cascade */
 if(gl_Timer0_100msec)
  gl_Timer0_100msec--;
 else {
  gl_Timer0_100msec=100;

  /**********************************************************************/
  /**********************************************************************/


  if(gl_TComExt)
    gl_TComExt--;
  }
}



//------------------------------------------------------------------------------------------------------------
#pragma interrupt_handler uart0_rx_isr:12
void uart0_rx_isr(void)  /* */
{
 //uart has received a character in UDR
}




//------------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------------
void main(void)  /* */
{
  //Setup CPU internals
  init_devices();


 //============================================================================

  //============================================================================
  // EEPROM-Parameter laden
  // Parameter des EEPROM, wenn sich an den ersten 5 Bytes nicht das Testmuster
  // findet, wird neu mit Defaults initialisiert.



/**********************************************************************************************************************************/
/**********************************************************************************************************************************/
/**********************************************************************************************************************************/

  LCD_reset();
  LCD_init();
  /* switch LCD-Backlight on */
  LCD_LED(ON);

  LCD_command(LCD_CURSOR_OFF);
  LCD_command(LCD_HOME);
  LCD_command(LCD_CLEAR);
  LCD_puts_const(headline1);
  gl_T0_aux_1=20; while(gl_T0_aux_1);
  LCD_command(LCD_HOME);
  LCD_command(LCD_CLEAR);

  while(1){

    LCD_command(LCD_HOME);
    LCD_puts_const(headline1);
    gl_T0_aux_1=10; while(gl_T0_aux_1);

    LCD_command(LCD_HOME);
    LCD_puts_const(headline2);
    gl_T0_aux_1=10; while(gl_T0_aux_1);

    LCD_command(LCD_HOME);
    LCD_puts_const(headline3);
    gl_T0_aux_1=10; while(gl_T0_aux_1);

    LCD_command(LCD_HOME);
    LCD_puts_const(headline4);
    gl_T0_aux_1=10; while(gl_T0_aux_1);
    LCD_command(LCD_HOME);
    LCD_puts_const(headline5);
    gl_T0_aux_1=10; while(gl_T0_aux_1);

  }

}
